*trigger
128  
*oned
0..255  s 4096
1000..1255  s 4096
3001..3002  s 1024
3006  s 4096
3007  s 1024
3110..3112  s 4096
3120..3122  s 4096
3141  s 1024
4000  s 1024 
4003  s 1024
*twod
2000..2255  s 512 512
3003..3005  s 512 512
3008  s 512 512
3100..3102  s 512 512
3130..3132  s 512 512
3140  s 512 512
3142  s 512 512
4001  s 512 512
4002  s 64 64
*vars
*sort
C----67---------------------------------------------------------------72------80
      SUBROUTINE init

      IMPLICIT none

      SAVE
C
C     External functions
C
      EXTERNAL dtime, elab2ecm, s2order, s2_1_theta, s2_3_theta
      EXTERNAL phi_0, phi_1, phi_2, phi_3
C
      INTEGER int, rshift, s2order
      INTEGER phi_0, phi_1, phi_2, phi_3
C
      REAL dtime, elab2ecm, float, rand, s2_1_theta, s2_3_theta
C
C     Parameter variables
C
      INTEGER maxadcs
      PARAMETER (maxadcs = 2200)
      INTEGER adcs_max
      PARAMETER (adcs_max = 8*32)
      INTEGER tdcs_max
      PARAMETER (tdcs_max = 1*112)
      INTEGER maxscalers
      PARAMETER (maxscalers = 8)
      INTEGER maxepics
      PARAMETER (maxepics = 64)
      INTEGER event_prescaler
      PARAMETER (event_prescaler = 100000)
      INTEGER scaler_prescaler
      PARAMETER (scaler_prescaler = 100000)
      INTEGER epics_prescaler
      PARAMETER (epics_prescaler = 100000)
C
      LOGICAL csm
      PARAMETER (csm = .true.)
C
C     Local variables
C
      INTEGER channel, data(0:maxadcs-1), epics_counter, events
      INTEGER events_old
      INTEGER good_s2_1, good_s2_1_front(48), good_s2_1_back(16)
      INTEGER good_s2_2, good_s2_2_front(48), good_s2_2_back(16)
      INTEGER good_s2_3, good_s2_3_front(48), good_s2_3_back(16), i
      INTEGER*2 i2(2)
      INTEGER i4, ierr, iflag, ireturn, j, k, l, m
      INTEGER m_adc, m_tdc, n, scaler(0:maxscalers-1)
      INTEGER scaler_old(0:maxscalers-1), sc_counter, type, w(32)
      INTEGER e_diff, pi
C
      LOGICAL hit(0:maxadcs-1), alpha_s2
      LOGICAL good_s2_1_event, good_s2_2_event, good_s2_3_event, alpha
C
      REAL c(32), de, e, e_alpha, e_hi, epics(0:maxepics-1), e_cm, e_lab
      REAL gain(0:maxadcs-1), offset(0:maxadcs-1), r4, dt
      REAL rate(0:maxscalers-1), time(2), xm, xn
      REAL event_rate
C
C     Namelists
C
      NAMELIST /variables/ gain, offset, c, w
C
C     Common variables
C
      INTEGER*2 adc_data(0:maxadcs-1)
C
      COMMON /fdata/ adc_data
C
C     Common variables
C
      INTEGER*2 adcs(0:maxadcs-1)
C
      COMMON /fid/ adcs
C
C     Common variables
C
      INTEGER noadcs
C
      COMMON /fmult/ noadcs
C
      EQUIVALENCE  ( i4, i2( 1 ) )
C
C----67---------------------------------------------------------------72------80

      WRITE ( 6, * ) ' *** IS607 sort1 - November 2017'
      WRITE ( 6, * ) ' *** Entry init commences'

C     Initialise arrays for unpacked event data.

      DO i = 0, maxadcs - 1
       data( i ) = 0
       hit( i ) = .FALSE.
      ENDDO

C     Initialise gains/offsets

      DO i = 0, maxadcs - 1
       gain( i ) = 1.0
       offset( i ) = 0.0
      ENDDO

C     Initialise constants/1D windows

      DO i = 1, 32
       c( i ) = 1.0
       w( i ) = 0
      ENDDO

C     Initialise scalers

      DO i = 0, maxscalers - 1
       scaler( i ) = 0
       scaler_old( i ) = 0
       rate( i ) = 0.0
      ENDDO

C     Initialise counters

      sc_counter = 0
      epics_counter = 0
      events = 0
      events_old = 0

C     Read program variables via NAMELIST I/O

      OPEN( 1, FILE = '/scratch/daq/sort/variables.dat',
     + IOSTAT = ierr )
      IF ( ierr.NE.0 ) THEN
       WRITE( 6, * ) ' *** OPEN I/O error:', ierr
       RETURN
      ENDIF
      READ( 1, NML = variables, IOSTAT = ierr )
      IF ( ierr.NE.0 ) THEN
       WRITE( 6, * ) ' *** READ I/O error:', ierr
      ENDIF
      CLOSE( 1, IOSTAT = ierr )
      IF ( ierr.NE.0 ) THEN
       WRITE( 6, * ) ' *** CLOSE I/O error:', ierr
       RETURN
      ENDIF      

C     Display program variables

      DO i = 0, adcs_max-1, 8
       WRITE( 6, 9001 ) i, i+7, ( gain( j ), j = i, i+7 )
      ENDDO

      DO i = 0, adcs_max-1, 8
       WRITE( 6, 9002 ) i, i+7, ( offset( j ), j = i, i+7 )
      ENDDO

      DO i = 1000, 1000+tdcs_max-1, 8
       WRITE( 6, 9002 ) i, i+7, ( offset( j ), j = i, i+7 )
      ENDDO

      DO i = 1, 32, 8
       WRITE( 6, 9003 ) i, i+7, ( c( j ), j = i, i+7 )
      ENDDO

      DO i = 1, 32, 8
       WRITE( 6, 9004 ) i, i+7, ( w( j ), j = i, i+7 )
      ENDDO

      WRITE ( 6, * ) ' *** Entry init ends'

      RETURN

C----67---------------------------------------------------------------72------80

      ENTRY sortin

      events = events + 1

      IF ( MOD( events, event_prescaler ).EQ.0 ) THEN
       event_rate = FLOAT( events - events_old ) / dtime(time)
       WRITE( 6, 9000 ) events, event_rate
       events_old = events
      ENDIF

C     Convert Eurogam type 0 ID to (a more) logical channel number.
C	ADC data	channels 0-999
C	TDC data	channels 1000-1999
C	Scaler data	channels 2000-2099
C	EPICS data	channels 2100-2199

      call egid2logical( noadcs, adcs, adc_data, type, csm )

C----67---------------------------------------------------------------72------80
C     Event data.

      IF ( MOD( events, event_prescaler ).EQ.0 ) THEN
       WRITE( 6, * ) ' *** Packed event:', events, ' noadcs:', noadcs
       DO i = 0, noadcs - 1
        WRITE( 6, 9050 ) adcs( i ), adc_data( i )
       ENDDO
      ENDIF

C     Unpack event data from packed data arrays.

      DO i = 0, noadcs - 1
       IF ( adcs( i ).GE.0 .AND. adcs( i ).LT.maxadcs ) THEN
        data( adcs( i ) ) = adc_data( i )
        hit( adcs( i ) ) = .TRUE.
       ENDIF
      ENDDO

      IF ( MOD( events, event_prescaler ).EQ.0 ) THEN
       WRITE( 6, * ) ' *** Unpacked event:', events
       DO i = 0, adcs_max-1, 16
        WRITE(6,9060) i, i+15, (data(j),hit(j),j=i,i+15)
       ENDDO
       DO i = 1000, 1000+tdcs_max-1, 16
        WRITE(6,9060) i, i+15, (data(j),hit(j),j=i,i+15)
       ENDDO
      ENDIF

C----67---------------------------------------------------------------72------80
C     Scaler data.

      IF ( AND( X'00000002', type ).EQ.2 ) THEN

       j = 0

       IF ( MOD( sc_counter, scaler_prescaler ).EQ.0 ) THEN

        DO  i = 2000, 2000 + ( 2 * maxscalers ) - 1, 2
         i2( 1 ) = data( i + 1 )
         i2( 2 ) = data( i )
         scaler( j ) = i4
         j = j + 1
        ENDDO

        dt = FLOAT( scaler( 2 ) - scaler_old( 2 ) ) / 1000.0

        DO i = 0, maxscalers - 1
	 IF ( ( scaler( 2 ) - scaler_old( 2 ) ) .LE. 0 ) THEN
	  rate( i ) = 0.0
	 ELSE
	  rate( i ) = 1000.0 * FLOAT( scaler(i) - scaler_old(i) ) / dt
	 ENDIF
	 CALL set1d( i+3100, MOD(channel, 8192), INT( rate(i)+0.5 ) )
        ENDDO

        DO i = 0, maxscalers - 1
         scaler_old( i ) = scaler( i )
        ENDDO

        WRITE( 6, 9010 ) sc_counter
        DO i = 0, maxscalers-1, 4
         WRITE( 6, 9020 ) i, i+3, ( scaler(j),
     +                    1.0E-03 * rate(j), j = i, i+3 )
        ENDDO

        channel = channel + 1

       ENDIF

       sc_counter = sc_counter + 1

C----67---------------------------------------------------------------72------80
C     EPICS data.

      ELSEIF ( AND( X'00000004', type ).EQ.4 ) THEN

       epics_counter = epics_counter + 1
       WRITE( 6, 9010 ) epics_counter

C----67---------------------------------------------------------------72------80
C     Unexpected data type.

      ELSEIF ( AND( X'00000008', type ).EQ.8 ) THEN

       RETURN

C     If event does not contain any ADC/TDC data return.

      ELSEIF ( AND( X'00000001', type ).NE.1 ) THEN

       RETURN

      ENDIF

C----67---------------------------------------------------------------72------80
C     Sort unpacked event data

      m_adc = 0
      m_tdc = 0

C----67---------------------------------------------------------------72------80
C     ADCs

      DO i = 0, adcs_max-1
       IF ( hit( i ) ) THEN
        CALL inc1d( 3000, i )
        IF ( i.GE.0 .AND. i.LE.63 ) THEN
         j = INT( c(1) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         CALL inc1d( i, j )
         CALL inc2d( 3003, RSHIFT(j,3), i )
         CALL inc2d( 3008, RSHIFT(j,3), s2order( i ))
        ENDIF
        IF ( i.GE.64 .AND. i.LE.127 ) THEN
         j = INT( c(2) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         CALL inc1d( i, j )
         CALL inc2d( 3003, RSHIFT(j,3), i )
         CALL inc2d( 3008, RSHIFT(j,3), s2order( i - 64 ) + 64 )
        ENDIF
        IF ( i.GE.128 .AND. i.LE.191 ) THEN
         j = INT( c(3) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         CALL inc1d( i, j )
         CALL inc2d( 3003, RSHIFT(j,3), i )
         CALL inc2d( 3008, RSHIFT(j,3), s2order( i - 128 ) + 128 )
        ELSE
         j = INT( c(4) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         CALL inc1d( i, j )
         CALL inc2d( 3003, RSHIFT(j,3), i )
        ENDIF
        m_adc = m_adc + 1    
       ENDIF
      ENDDO

C----67---------------------------------------------------------------72------80
C     TDCs
      
      DO i = 1000, 1000+tdcs_max-1
       IF ( hit( i ) ) THEN
        j = INT( data(i) - offset(i) + rand(iflag) )
        CALL inc1d( i, j )
        CALL inc1d( 3001, i - 1000)
        CALL inc2d( 3004, j, i - 1000 )
        m_tdc = m_tdc + 1
       ENDIF
      ENDDO

C----67---------------------------------------------------------------72------80
C     Multiplicity

      CALL inc1d( 3006, m_adc )
      CALL inc1d( 3006, m_tdc + 1000 )
      CALL inc1d( 3006, m_adc + m_tdc + 2000 )

C----67---------------------------------------------------------------72------80
C     ADC versus TDC

      DO i = 0, adcs_max-1
       IF ( hit( i ).AND.hit( i+1000 ) ) THEN
        j = INT( c(1) * gain(i) * (data(i) - offset(i))+rand(iflag))
        k = INT( data(i+1000) - offset(i+1000) + rand(iflag) ) 
        CALL inc2d( i+2000, RSHIFT( j, 3 ), k )
        CALL inc1d( 3002, i )
       ENDIF
      ENDDO        

C----67---------------------------------------------------------------72------80
C     ADC / TDC correlation

      DO i = 0, adcs_max-1
       IF ( hit( i ) ) THEN
        DO j = 1000, 1000+tdcs_max-1
         IF ( hit( j ) ) THEN
          CALL inc2d( 3005, i, j-1000 )
         ENDIF
        ENDDO
       ENDIF
      ENDDO

C----67---------------------------------------------------------------72------80
C     Reject pulser events 

      IF ( m_adc.GT.32 ) GOTO 1000

C----67---------------------------------------------------------------72------80
C     S2-1 good event selection

      e_diff = 0
      DO i = 1, 48
       good_s2_1_front(i) = -1
       good_s2_1_back(i) = -1
      ENDDO
      good_s2_1_event = .FALSE.
      good_s2_1 = 0

      DO i = 0, 47
       DO j = 48, 63
        IF ( hit( i ) .AND. hit( j ) ) THEN 
         m = INT( c(1) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         xm = c(1) * gain(k) * (data(k) - offset(k))
         n = INT( c(1) * gain(j) * (data(j) - offset(j)) + rand(iflag) )
         xn = c(1) * gain(l) * (data(l) - offset(l))
         CALL inc2d( 3100, RSHIFT( m, 2 ), RSHIFT( n, 2 ) )
         e_diff = INT( xm - xn + 2048.0 )
         CALL inc1d( 3110, e_diff )
         IF ( e_diff.GE.w(1) .AND. e_diff.LE.w(2)
     +       .AND.good_s2_1.LT.16 ) THEN
          good_s2_1 = good_s2_1 + 1
          good_s2_1_event = .TRUE.
          good_s2_1_front(good_s2_1) = i
          good_s2_1_back(good_s2_1) = j
          CALL inc1d( 3120, e_diff )
          CALL inc2d( 3130, RSHIFT( m, 2 ), RSHIFT( n, 2 ) )
         ENDIF
        ENDIF
       ENDDO
      ENDDO
    
      DO i = 0, 63
       hit(i) = .FALSE.
      ENDDO
      IF ( good_s2_1.GT.0 ) THEN
       DO i = 1, good_s2_1
        hit( good_s2_1_front(i) ) = .TRUE.
        hit( good_s2_1_back(i) ) = .TRUE.
       ENDDO
      ENDIF

C----67---------------------------------------------------------------72------80
C     S2-2 good event selection

      e_diff = 0
      DO i = 1, 48
       good_s2_2_front(i) = -1
       good_s2_2_back(i) = -1
      ENDDO
      good_s2_2_event = .FALSE.
      good_s2_2 = 0

      DO i = 64, 111
       DO j = 112, 127
        IF ( hit( i ) .AND. hit( j ) ) THEN 
         m = INT( c(2) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         xm = c(2) * gain(i) * (data(i) - offset(i))
         n = INT( c(2) * gain(j) * (data(j) - offset(j)) + rand(iflag) )
         xn = c(2) * gain(j) * (data(j) - offset(j))
         CALL inc2d( 3101, RSHIFT( m, 2 ), RSHIFT( n, 2 ) )
         e_diff = INT( xm - xn + 2048.0 )
         CALL inc1d( 3111, e_diff )
         IF ( e_diff.GE.w(3) .AND. e_diff.LE.w(4)
     +       .AND.good_s2_2.LT.16 ) THEN
          good_s2_2 = good_s2_2 + 1
          good_s2_2_event = .TRUE.
          good_s2_2_front(good_s2_2) = i
          good_s2_2_back(good_s2_2) = j
          CALL inc1d( 3121, e_diff )
          CALL inc2d( 3131, RSHIFT( m, 2 ), RSHIFT( n, 2 ) )
         ENDIF
        ENDIF
       ENDDO
      ENDDO
    
      DO i = 64, 127
       hit(i) = .FALSE.
      ENDDO
      IF ( good_s2_2.GT.0 ) THEN
       DO i = 1, good_s2_2
        hit( good_s2_2_front(i) ) = .TRUE.
        hit( good_s2_2_back(i) ) = .TRUE.
       ENDDO
      ENDIF

C----67---------------------------------------------------------------72------80
C     S2-3 good event selection

      e_diff = 0
      DO i = 1, 48
       good_s2_3_front(i) = -1
       good_s2_3_back(i) = -1
      ENDDO
      good_s2_3_event = .FALSE.
      good_s2_3 = 0

      DO i = 128, 175
       DO j = 176, 191
        IF ( hit( i ) .AND. hit( j ) ) THEN 
         m = INT( c(3) * gain(i) * (data(i) - offset(i)) + rand(iflag) )
         xm = c(3) * gain(i) * (data(i) - offset(i))
         n = INT( c(3) * gain(j) * (data(j) - offset(j)) + rand(iflag) )
         xn = c(3) * gain(j) * (data(j) - offset(j))
         CALL inc2d( 3102, RSHIFT( m, 2 ), RSHIFT( n, 2 ) )
         e_diff = INT( xm - xn + 2048.0 )
         CALL inc1d( 3112, e_diff )
         IF ( e_diff.GE.w(5) .AND. e_diff.LE.w(6)
     +       .AND.good_s2_3.LT.16 ) THEN
          good_s2_3 = good_s2_3 + 1
          good_s2_3_event = .TRUE.
          good_s2_3_front(good_s2_3) = i
          good_s2_3_back(good_s2_3) = j
          CALL inc1d( 3122, e_diff )
          CALL inc2d( 3132, RSHIFT( m, 2 ), RSHIFT( n, 2 ) )
         ENDIF
        ENDIF
       ENDDO
      ENDDO

      DO i = 128, 191
       hit(i) = .FALSE.
      ENDDO
      IF ( good_s2_3.GT.0 ) THEN
       DO i = 1, good_s2_3
        hit( good_s2_3_front(i) ) = .TRUE.
        hit( good_s2_3_back(i) ) = .TRUE.
       ENDDO
      ENDIF

C----67---------------------------------------------------------------72------80
C     Good S2-1/S2-2/S2-3 events

      CALL inc1d( 3007, good_s2_1 )
      CALL inc1d( 3007, good_s2_2 + 100 )
      CALL inc1d( 3007, good_s2_3 + 200 )


C----67---------------------------------------------------------------72------80
C     Select S2-1/S2-2 (alpha) events

      alpha = .FALSE.

      IF ( good_s2_1.EQ.1 .AND. good_s2_2.EQ.1 ) THEN

       i = good_s2_1_front( 1 )
       de = c(1) * gain( i ) * ( data( i ) - offset( i ) )

       j = good_s2_2_front( 1 )
       e = c(2) * gain( j ) * ( data( j ) - offset( j ) )

       j = INT( de + 0.5 )
       k = INT( e + 0.5 )
       CALL inc2d( 3140, k, j )
       pi = INT( c(8) * ( (0.1*(e+de))**c(7) - (0.1*e)**c(7) ) + 0.5 )
       CALL inc1d( 3141, pi )
       CALL inc2d( 3142, pi, INT( de + e + 0.5 ) )

       IF ( pi.GE.w(7) .AND. pi.LE.w(8) ) THEN
        alpha = .TRUE.
        e_alpha = de + e
       ENDIF
  
      ENDIF

C----67---------------------------------------------------------------72------80
C     Select alpha/S2-3 events

      IF ( alpha .AND. good_s2_3.EQ.1 ) THEN

       k = good_s2_3_front( 1 )
       e_hi = c(3) * gain( k ) * ( data( k ) - offset( k ) )

       CALL inc1d( 4000, INT( 0.1 * ( e_alpha + e_hi ) + 0.5 ) )
       CALL inc2d( 4001, INT( 0.1 * e_alpha + 0.5 ),
     +                   INT( 0.1 * e_hi + 0.5 ) )
       CALL inc2d( 4002, s2order( i ), s2order( k - 128 ) )
       CALL inc1d( 4003, s2order( good_s2_1_back( 1 ) )
     +             - s2order( good_s2_3_back( 1 ) - 128 ) + 100 )

      ENDIF

C----67---------------------------------------------------------------72------80      
C     Re-initialise unpacked data arrays using the packed data arrays.
C     Note: assumes packed data arrays are not modified by event.

 1000 CONTINUE

      DO i = 0, noadcs - 1
       data( adcs( i ) ) = 0
       hit( adcs( i ) ) = .FALSE.
      ENDDO

      RETURN

C----67---------------------------------------------------------------72------80      

      ENTRY finish
      WRITE ( 6, * ) ' *** Entry finish '
      RETURN

C----67---------------------------------------------------------------72------80

 9001 FORMAT( '   gain(', i4, '-', i4, ')', 8f8.5 )
 9002 FORMAT( ' offset(', i4, '-', i4, ')', 8f8.2 )
 9003 FORMAT( '      c(', i4, '-', i4, ')', 8f8.3 )
 9004 FORMAT( '      w(', i4, '-', i4, ')', 8i8 )
 9000 FORMAT(/' ***        event: ', i10, ' (', F9.2, '/s)' )
 9010 FORMAT(/' *** scaler event: ', i10 )
 9020 FORMAT( ' scaler(', i2, '-', i2, ')', 4(i10,1x,'(',F9.2,'/s)') )
 9030 FORMAT(/' ***  epics event:', i10 )
 9040 FORMAT( '  epics(', i2, '-', i2, ')', 8(1x,g13.6) )
 9050 FORMAT( 2(1x,i4) )
 9060 FORMAT( 2(1x,i4), 16(1x,i4,1x,l1) )

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      SUBROUTINE egid2logical( noadcs, adcs, adc_data, type, csm )

C     Set logical argument csm true if TDCs are operated in common
C     stop (emulation) mode.

      IMPLICIT none
C
      INTEGER and, rshift
C
C     Parameter variables
C
      INTEGER maxadcs
      PARAMETER (maxadcs = 2200)

C     Eurogam type 0 group IDs are defined in file /MIDAS/TUDA/tcl/GroupDefn.tcl

      INTEGER min_adc_gid
      PARAMETER (min_adc_gid = 1)
      INTEGER max_adc_gid
      PARAMETER (max_adc_gid = 19)
      INTEGER min_tdc_gid
      PARAMETER (min_tdc_gid = 20)
      INTEGER max_tdc_gid
      PARAMETER (max_tdc_gid = 29)
      INTEGER scaler_gid
      PARAMETER (scaler_gid = 31)
      INTEGER epics_gid
      PARAMETER (epics_gid = 30)
C
C     Argument variables
C
      INTEGER*2 adcs(0:maxadcs-1), adc_data(0:maxadcs-1)
      INTEGER noadcs, type
C
      LOGICAL csm
C
C     Local variables
C
      INTEGER channel, data0, data1, data2, data3, data4, gid, i, item
      INTEGER tdc0, tdc1, tdc2, tdc3, tdc4

C----67---------------------------------------------------------------72------80

      type = 0

      DO 100 i = 0, noadcs - 1

       gid = AND( X'000000ff', adcs( i ) )
       item = AND( X'0000003f', RSHIFT( adcs( i ), 8 ) )

       IF ( ( gid.GE.min_ADC_gid .AND. gid.LE.max_ADC_gid )
     +      .OR.
     +      ( gid.GE.min_TDC_gid .AND. gid.LE.max_TDC_gid ) ) THEN

        type = IBSET( type, 0 )

       ENDIF

       IF ( gid.GE.min_ADC_gid .AND. gid.LE.max_ADC_gid ) THEN

        channel = 32 * ( gid - min_ADC_gid ) + item

       ELSEIF( gid.GE.min_TDC_gid .AND. gid.LE.max_TDC_gid ) THEN

C       Each CAEN V767 TDC module is assigned two group IDs
C       for channels 0-63 and 64-127.

        channel = 64 * ( gid - min_TDC_gid ) + item

C       First sixteen channels of each CAEN V767 TDC module are unused in common
C       stop mode.

        IF ( csm ) THEN
         channel = channel - 16 * ( 1 + ( gid - min_TDC_gid ) / 2 )
        ENDIF
        channel = channel + 1000

       ELSEIF( gid.EQ.scaler_gid) THEN

        channel = item + 2000
        type = IBSET( type, 1 )

       ELSEIF( gid.EQ.EPICS_gid ) THEN

        channel = item + 2100
        type = IBSET( type, 2 )

       ELSE

        WRITE( 6, 9000 ) gid
        type = IBSET( type, 3 )
        RETURN

       ENDIF

      adcs( i ) = channel

  100 CONTINUE

      IF (type.NE.0 ) RETURN

      IF ( csm ) RETURN

C     Search for CAEN V767 channel 0 data

      tdc0 = -1
      tdc1 = -1
      tdc2 = -1
      tdc3 = -1
      tdc4 = -1

      DO 110 i = 0, noadcs - 1

       IF ( adcs( i ).EQ.1000 ) THEN
        tdc0 = i
        data0 = adc_data( i )
        adcs( i ) = 3000
       ENDIF
       IF ( adcs( i ).EQ.1128 ) THEN
        tdc1 = i
        data1 = adc_data( i )
        adcs( i ) = 3128
       ENDIF
       IF ( adcs( i ).EQ.1256 ) THEN
        tdc2 = i
        data2 = adc_data( i )
        adcs( i ) = 3256
       ENDIF
       IF ( adcs( i ).EQ.1384 ) THEN
        tdc3 = i
        data3 = adc_data( i )
        adcs( i ) = 3384
       ENDIF
       IF ( adcs( i ).EQ.1512 ) THEN
        tdc4 = i
        data4 = adc_data( i )
        adcs( i ) = 3512
       ENDIF

  110 CONTINUE

      DO 120 i = 0, noadcs - 1

        IF ( tdc0.LT.0 .AND.
     +       ( adcs(i).GE.1016 .OR. adcs(i).LE.1127 ) ) THEN
         adcs( i ) = adcs( i ) + 2000
        ENDIF
        IF ( tdc1.LT.0 .AND.
     +       ( adcs(i).GE.1144 .OR. adcs(i).LE.1255 ) ) THEN
         adcs( i ) = adcs( i ) + 2000
        ENDIF
        IF ( tdc2.LT.0 .AND.
     +       ( adcs(i).GE.1272 .OR. adcs(i).LE.1383 ) ) THEN
         adcs( i ) = adcs( i ) + 2000
        ENDIF
        IF ( tdc3.LT.0 .AND.
     +       ( adcs(i).GE.1400 .OR. adcs(i).LE.1511 ) ) THEN
         adcs( i ) = adcs( i ) + 2000
        ENDIF
        IF ( tdc4.LT.0 .AND.
     +       ( adcs(i).GE.1528 .OR. adcs(i).LE.1639 ) ) THEN
         adcs( i ) = adcs( i ) + 2000
        ENDIF

  120 CONTINUE

C     Calculate common stop TDC values

      DO 130 i = 0, noadcs - 1

        IF ( tdc0.GE.0 .AND.
     +       ( adcs(i).GE.1016 .OR. adcs(i).LE.1127 ) ) THEN
         adc_data( i ) = adc_data( i ) - data0
         adcs( i ) = adcs( i ) - 16
        ENDIF
        IF ( tdc1.GE.0 .AND.
     +       ( adcs(i).GE.1144 .OR. adcs(i).LE.1255 ) ) THEN
         adc_data( i ) = adc_data( i ) - data1
         adcs( i ) = adcs( i ) - 32
        ENDIF
        IF ( tdc2.GE.0 .AND.
     +       ( adcs(i).GE.1272 .OR. adcs(i).LE.1383 ) ) THEN
         adc_data( i ) = adc_data( i ) - data2
         adcs( i ) = adcs( i ) - 48
        ENDIF
        IF ( tdc3.GE.0 .AND.
     +       ( adcs(i).GE.1400 .OR. adcs(i).LE.1511 ) ) THEN
         adc_data( i ) = adc_data( i ) - data3
         adcs( i ) = adcs( i ) - 64
        ENDIF
        IF ( tdc4.GE.0 .AND.
     +       ( adcs(i).GE.1528 .OR. adcs(i).LE.1639 ) ) THEN
         adc_data( i ) = adc_data( i ) - data4
         adcs( i ) = adcs( i ) - 80
        ENDIF

  130 CONTINUE

      RETURN

C----67---------------------------------------------------------------72------80

 9000 FORMAT( '*** ERROR: egid2logical: unexpected GID: ', i10 )

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80
C     Laboratory angles of MSL type S2 DSSSD dE (alpha dE-E telescope)

      FUNCTION s2_1_theta( channel )

      REAL array( 0:47 ), s2_1_theta
      INTEGER channel

C     Assumes target - s2 distance = 9.5cm

      DATA array / 
     +  7.037,  7.329,  7.620,  7.911,  8.201,  8.491,  8.780,  9.069,
     +  9.358,  9.646,  9.934, 10.221, 10.507, 10.793, 11.079, 11.364,
     + 11.648, 11.932, 12.215, 12.497, 12.779, 13.061, 13.341, 13.621,
     + 13.901, 14.179, 14.457, 14.735, 15.011, 15.287, 15.563, 15.837,
     + 16.111, 16.384, 16.656, 16.927, 17.198, 17.468, 17.737, 18.005,
     + 18.272, 18.539, 18.805, 19.070, 19.334 ,19.597, 19.859, 20.121 /

      s2_1_theta = array( channel )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80
C     Laboratory angles of MSL type S2 DSSSD E (HI)

      FUNCTION s2_3_theta( channel )

      REAL array( 0:47 ), s2_3_theta
      INTEGER channel

C     Assumes target - s2 distance = 9.5cm

      DATA array / 
     +  7.037,  7.329,  7.620,  7.911,  8.201,  8.491,  8.780,  9.069,
     +  9.358,  9.646,  9.934, 10.221, 10.507, 10.793, 11.079, 11.364,
     + 11.648, 11.932, 12.215, 12.497, 12.779, 13.061, 13.341, 13.621,
     + 13.901, 14.179, 14.457, 14.735, 15.011, 15.287, 15.563, 15.837,
     + 16.111, 16.384, 16.656, 16.927, 17.198, 17.468, 17.737, 18.005,
     + 18.272, 18.539, 18.805, 19.070, 19.334 ,19.597, 19.859, 20.121 /

      s2_3_theta = array( channel )

      RETURN

C----67---------------------------------------------------------------72------80

      END
C----67---------------------------------------------------------------72------80

      FUNCTION cd_theta( channel )

      REAL array( 0:15 ), cd_theta
      INTEGER channel

C     Assumes target - cd distance = 34.7cm

      DATA array / 
     +  1.642,  1.972,  2.302,  2.632,  2.961,  3.290,  3.620,  3.948,
     +  4.277,  4.605,  4.933, 5.261, 5.588, 5.915, 6.241, 6.568 /

      cd_theta = array( channel )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      REAL FUNCTION tof( x, e )

C     Function returns time-of-flight (variable "tof": units ns) for protons
C     (mass variable "m_p": units MeV/c**2) for input values of flight-path
C     (variable "x": units mm) and energy (variable "e": units MeV).

      REAL a
      REAL c
      REAL e
      REAL m_p
      REAL v
      REAL x

C     Speed of light (variable c: units mm/ns)

      DATA c   / 299.7925 /
      DATA m_p / 938.2796 /

C----67---------------------------------------------------------------72------80

      a = (1.0 + ( e / m_p ))**2
      v = c * sqrt(1.0 - ( 1.0 / a ))
      tof = x / v
      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION elab2ecm( e_lab, theta_lab )

      REAL e_lab, elab2ecm, pi, leda_1_theta, theta_lab, m_1, m_2

C     21Ne
C      m_1 = 20.993847
C     21Na
      m_1 = 20.997655
      m_2 = 1.007825
      pi = 3.141592654

      theta_lab = theta_lab * pi / 180.0

      elab2ecm = ( e_lab * ( m_1 + m_2 ) )
     +           / ( 4.0 * m_1 * cos( theta_lab ) * cos( theta_lab ) )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION w_0_theta( i, j )

      INTEGER i, j

      REAL d, x, y, pi

C     Target - W-0 distance (mm)

      d = 240.0

      IF ( i.LE.7 ) x = FLOAT( 7 - i ) * 3.10 + 1.55
      IF ( i.GE.8 ) x = FLOAT( i - 8 ) * 3.10 + 1.55
      IF ( j.LE.7 ) y = FLOAT( 7 - j ) * 3.10 + 1.55
      IF ( j.GE.8 ) y = FLOAT( j - 8 ) * 3.10 + 1.55

      w_0_theta = ATAN( SQRT( x**2.0 + y**2.0 ) / d ) * 180.0 / pi

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION s2order( channel )

      INTEGER array( 0:63 ), s2order, channel

C      DATA array /  47, 45, 43, 41, 39, 37, 35, 33,
C     +              31, 29, 27, 25, 23, 21, 19, 17,
C     +              48, 49, 50, 51, 52, 53, 54, 55,
C     +              56, 57, 58, 59, 60, 61, 62, 63,
C     +              16, 18, 20, 22, 24, 26, 28, 30,
C     +              32, 34, 36, 38, 40, 42, 44, 46,
C     +              15, 13, 11,  9,  7,  5,  3,  1,
C     +               0,  2,  4,  6,  8, 10, 12, 14 /

      DATA array /
     +  47, 45, 43, 41, 39, 37, 35, 33, 31, 29, 27, 25, 23, 21, 19, 17,
     +  15, 13, 11,  9,  7,  5,  3,  1,  0,  2,  4,  6,  8, 10, 12, 14,
     +  16, 18, 20, 22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46,
     +  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63 /

      s2order = array( channel )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION phi_0( x,y )

      INTEGER array( 0:24*16-1 ), phi_0, x, y 

      DATA array /  
     +             0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /

      phi_0 = array( 24*(15-y) + x )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION phi_1( x,y )

      INTEGER array( 0:24*16-1 ), phi_1, x, y 

      DATA array /  
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
     +             0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /

      phi_1 = array( 24*(15-y) + x )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION phi_2( x,y )

      INTEGER array( 0:24*16-1 ), phi_2, x, y 

      DATA array /  
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,
     +             1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,   
     +             0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /

      phi_2 = array( 24*(15-y) + x )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80

      FUNCTION phi_3( x,y )

      INTEGER array( 0:24*16-1 ), phi_3, x, y 

      DATA array /  
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
     +             1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     +             1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
     +             0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,
     +             0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,
     +             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1 /

      phi_3 = array( 24*(15-y) + x )

      RETURN

C----67---------------------------------------------------------------72------80

      END

C----67---------------------------------------------------------------72------80



